import unittest
import io
import contextlib
from unittest.mock import patch

from tmc import points

from tmc.utils import load, get_stdout
main = load('src.main', 'main')


@points('2.4')
class MainTest(unittest.TestCase):

    def test_00_something_is_printed(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        if not printed:
            self.fail('Et tulostanut mitään!')

    def test_01_prints_all_to_different_lines(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        lines = printed.split('\n')
        self.assertTrue(len(lines)>1,msg='Et tulostanut kaikkia tuloksia omalle rivilleen.')

    def test_02_prints_correct_sqrtt(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[0].strip()
        a = float(line)
        import numpy as np
        self.assertTrue(np.isclose(a,np.sqrt(9),1e-8), msg='Et laskenut neliöjuurta oikein')

    def test_03_prints_correct_absolute(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[1].strip()
        a = float(line)
        import numpy as np
        self.assertTrue(np.isclose(a,np.abs(-9),1e-8), msg='Et laskenut itseisarvoa oikein')

    def test_04_prints_correct_cbrt_root(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[2].strip()
        a = float(line)
        import numpy as np
        self.assertTrue(np.isclose(a,np.cbrt(9),1e-8), msg='Et laskenut kuutiojuurta oikein')

    def test_05_prints_correct_neg_cbrt_root(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[3].strip()
        a = float(line)
        import numpy as np
        self.assertTrue(np.isclose(a,np.cbrt(-9),1e-8), msg='Et laskenut negatiivista kuutiojuurta oikein')

